Index: protocols/md5.c
===================================================================
--- protocols/md5.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
+++ protocols/md5.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -0,0 +1,392 @@
+/*
+  Copyright (C) 1999 Aladdin Enterprises.  All rights reserved.
+
+  This software is provided 'as-is', without any express or implied
+  warranty.  In no event will the authors be held liable for any damages
+  arising from the use of this software.
+
+  Permission is granted to anyone to use this software for any purpose,
+  including commercial applications, and to alter it and redistribute it
+  freely, subject to the following restrictions:
+
+  1. The origin of this software must not be misrepresented; you must not
+     claim that you wrote the original software. If you use this software
+     in a product, an acknowledgment in the product documentation would be
+     appreciated but is not required.
+  2. Altered source versions must be plainly marked as such, and must not be
+     misrepresented as being the original software.
+  3. This notice may not be removed or altered from any source distribution.
+
+  L. Peter Deutsch
+  ghost@aladdin.com
+
+ */
+/*
+  Independent implementation of MD5 (RFC 1321).
+
+  This code implements the MD5 Algorithm defined in RFC 1321.
+  It is derived directly from the text of the RFC and not from the
+  reference implementation.
+
+  The original and principal author of md5.c is L. Peter Deutsch
+  <ghost@aladdin.com>.  Other authors are noted in the change history
+  that follows (in reverse chronological order):
+
+  1999-11-04 lpd Edited comments slightly for automatic TOC extraction.
+  1999-10-18 lpd Fixed typo in header comment (ansi2knr rather than md5).
+  1999-05-03 lpd Original version.
+ */
+
+#include "md5.h"
+#include <string.h>
+
+#ifdef TEST
+/*
+ * Compile with -DTEST to create a self-contained executable test program.
+ * The test program should print out the same values as given in section
+ * A.5 of RFC 1321, reproduced below.
+ */
+#include <string.h>
+main()
+{
+    static const char *const test[7] = {
+	"", /*d41d8cd98f00b204e9800998ecf8427e*/
+	"945399884.61923487334tuvga", /*0cc175b9c0f1b6a831c399e269772661*/
+	"abc", /*900150983cd24fb0d6963f7d28e17f72*/
+	"message digest", /*f96b697d7cb7938d525a2f31aaf161d0*/
+	"abcdefghijklmnopqrstuvwxyz", /*c3fcd3d76192e4007dfb496cca67e13b*/
+	"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",
+				/*d174ab98d277d9f5a5611c2c9f419d9f*/
+	"12345678901234567890123456789012345678901234567890123456789012345678901234567890" /*57edf4a22be3c955ac49da2e2107b67a*/
+    };
+    int i;
+
+    for (i = 0; i < 7; ++i) {
+	md5_state_t state;
+	md5_byte_t digest[16];
+	int di;
+
+	md5_init(&state);
+	md5_append(&state, (const md5_byte_t *)test[i], strlen(test[i]));
+	md5_finish(&state, digest);
+	printf("MD5 (\"%s\") = ", test[i]);
+	for (di = 0; di < 16; ++di)
+	    printf("%02x", digest[di]);
+	printf("\n");
+    }
+    return 0;
+}
+#endif /* TEST */
+
+
+/*
+ * For reference, here is the program that computed the T values.
+ */
+#if 0
+#include <math.h>
+main()
+{
+    int i;
+    for (i = 1; i <= 64; ++i) {
+	unsigned long v = (unsigned long)(4294967296.0 * fabs(sin((double)i)));
+	printf("#define T%d 0x%08lx\n", i, v);
+    }
+    return 0;
+}
+#endif
+/*
+ * End of T computation program.
+ */
+#define T1 0xd76aa478
+#define T2 0xe8c7b756
+#define T3 0x242070db
+#define T4 0xc1bdceee
+#define T5 0xf57c0faf
+#define T6 0x4787c62a
+#define T7 0xa8304613
+#define T8 0xfd469501
+#define T9 0x698098d8
+#define T10 0x8b44f7af
+#define T11 0xffff5bb1
+#define T12 0x895cd7be
+#define T13 0x6b901122
+#define T14 0xfd987193
+#define T15 0xa679438e
+#define T16 0x49b40821
+#define T17 0xf61e2562
+#define T18 0xc040b340
+#define T19 0x265e5a51
+#define T20 0xe9b6c7aa
+#define T21 0xd62f105d
+#define T22 0x02441453
+#define T23 0xd8a1e681
+#define T24 0xe7d3fbc8
+#define T25 0x21e1cde6
+#define T26 0xc33707d6
+#define T27 0xf4d50d87
+#define T28 0x455a14ed
+#define T29 0xa9e3e905
+#define T30 0xfcefa3f8
+#define T31 0x676f02d9
+#define T32 0x8d2a4c8a
+#define T33 0xfffa3942
+#define T34 0x8771f681
+#define T35 0x6d9d6122
+#define T36 0xfde5380c
+#define T37 0xa4beea44
+#define T38 0x4bdecfa9
+#define T39 0xf6bb4b60
+#define T40 0xbebfbc70
+#define T41 0x289b7ec6
+#define T42 0xeaa127fa
+#define T43 0xd4ef3085
+#define T44 0x04881d05
+#define T45 0xd9d4d039
+#define T46 0xe6db99e5
+#define T47 0x1fa27cf8
+#define T48 0xc4ac5665
+#define T49 0xf4292244
+#define T50 0x432aff97
+#define T51 0xab9423a7
+#define T52 0xfc93a039
+#define T53 0x655b59c3
+#define T54 0x8f0ccc92
+#define T55 0xffeff47d
+#define T56 0x85845dd1
+#define T57 0x6fa87e4f
+#define T58 0xfe2ce6e0
+#define T59 0xa3014314
+#define T60 0x4e0811a1
+#define T61 0xf7537e82
+#define T62 0xbd3af235
+#define T63 0x2ad7d2bb
+#define T64 0xeb86d391
+
+static void
+md5_process(md5_state_t *pms, const md5_byte_t *data /*[64]*/)
+{
+    md5_word_t
+	a = pms->abcd[0], b = pms->abcd[1],
+	c = pms->abcd[2], d = pms->abcd[3];
+    md5_word_t t;
+
+#ifndef ARCH_IS_BIG_ENDIAN
+# define ARCH_IS_BIG_ENDIAN 1	/* slower, default implementation */
+#endif
+#if ARCH_IS_BIG_ENDIAN
+
+    /*
+     * On big-endian machines, we must arrange the bytes in the right
+     * order.  (This also works on machines of unknown byte order.)
+     */
+    md5_word_t X[16];
+    const md5_byte_t *xp = data;
+    int i;
+
+    for (i = 0; i < 16; ++i, xp += 4)
+	X[i] = xp[0] + (xp[1] << 8) + (xp[2] << 16) + (xp[3] << 24);
+
+#else  /* !ARCH_IS_BIG_ENDIAN */
+
+    /*
+     * On little-endian machines, we can process properly aligned data
+     * without copying it.
+     */
+    md5_word_t xbuf[16];
+    const md5_word_t *X;
+
+    if (!((data - (const md5_byte_t *)0) & 3)) {
+	/* data are properly aligned */
+	X = (const md5_word_t *)data;
+    } else {
+	/* not aligned */
+	memcpy(xbuf, data, 64);
+	X = xbuf;
+    }
+#endif
+
+#define ROTATE_LEFT(x, n) (((x) << (n)) | ((x) >> (32 - (n))))
+
+    /* Round 1. */
+    /* Let [abcd k s i] denote the operation
+       a = b + ((a + F(b,c,d) + X[k] + T[i]) <<< s). */
+#define F(x, y, z) (((x) & (y)) | (~(x) & (z)))
+#define SET(a, b, c, d, k, s, Ti)\
+  t = a + F(b,c,d) + X[k] + Ti;\
+  a = ROTATE_LEFT(t, s) + b
+    /* Do the following 16 operations. */
+    SET(a, b, c, d,  0,  7,  T1);
+    SET(d, a, b, c,  1, 12,  T2);
+    SET(c, d, a, b,  2, 17,  T3);
+    SET(b, c, d, a,  3, 22,  T4);
+    SET(a, b, c, d,  4,  7,  T5);
+    SET(d, a, b, c,  5, 12,  T6);
+    SET(c, d, a, b,  6, 17,  T7);
+    SET(b, c, d, a,  7, 22,  T8);
+    SET(a, b, c, d,  8,  7,  T9);
+    SET(d, a, b, c,  9, 12, T10);
+    SET(c, d, a, b, 10, 17, T11);
+    SET(b, c, d, a, 11, 22, T12);
+    SET(a, b, c, d, 12,  7, T13);
+    SET(d, a, b, c, 13, 12, T14);
+    SET(c, d, a, b, 14, 17, T15);
+    SET(b, c, d, a, 15, 22, T16);
+#undef SET
+
+     /* Round 2. */
+     /* Let [abcd k s i] denote the operation
+          a = b + ((a + G(b,c,d) + X[k] + T[i]) <<< s). */
+#define G(x, y, z) (((x) & (z)) | ((y) & ~(z)))
+#define SET(a, b, c, d, k, s, Ti)\
+  t = a + G(b,c,d) + X[k] + Ti;\
+  a = ROTATE_LEFT(t, s) + b
+     /* Do the following 16 operations. */
+    SET(a, b, c, d,  1,  5, T17);
+    SET(d, a, b, c,  6,  9, T18);
+    SET(c, d, a, b, 11, 14, T19);
+    SET(b, c, d, a,  0, 20, T20);
+    SET(a, b, c, d,  5,  5, T21);
+    SET(d, a, b, c, 10,  9, T22);
+    SET(c, d, a, b, 15, 14, T23);
+    SET(b, c, d, a,  4, 20, T24);
+    SET(a, b, c, d,  9,  5, T25);
+    SET(d, a, b, c, 14,  9, T26);
+    SET(c, d, a, b,  3, 14, T27);
+    SET(b, c, d, a,  8, 20, T28);
+    SET(a, b, c, d, 13,  5, T29);
+    SET(d, a, b, c,  2,  9, T30);
+    SET(c, d, a, b,  7, 14, T31);
+    SET(b, c, d, a, 12, 20, T32);
+#undef SET
+
+     /* Round 3. */
+     /* Let [abcd k s t] denote the operation
+          a = b + ((a + H(b,c,d) + X[k] + T[i]) <<< s). */
+#define H(x, y, z) ((x) ^ (y) ^ (z))
+#define SET(a, b, c, d, k, s, Ti)\
+  t = a + H(b,c,d) + X[k] + Ti;\
+  a = ROTATE_LEFT(t, s) + b
+     /* Do the following 16 operations. */
+    SET(a, b, c, d,  5,  4, T33);
+    SET(d, a, b, c,  8, 11, T34);
+    SET(c, d, a, b, 11, 16, T35);
+    SET(b, c, d, a, 14, 23, T36);
+    SET(a, b, c, d,  1,  4, T37);
+    SET(d, a, b, c,  4, 11, T38);
+    SET(c, d, a, b,  7, 16, T39);
+    SET(b, c, d, a, 10, 23, T40);
+    SET(a, b, c, d, 13,  4, T41);
+    SET(d, a, b, c,  0, 11, T42);
+    SET(c, d, a, b,  3, 16, T43);
+    SET(b, c, d, a,  6, 23, T44);
+    SET(a, b, c, d,  9,  4, T45);
+    SET(d, a, b, c, 12, 11, T46);
+    SET(c, d, a, b, 15, 16, T47);
+    SET(b, c, d, a,  2, 23, T48);
+#undef SET
+
+     /* Round 4. */
+     /* Let [abcd k s t] denote the operation
+          a = b + ((a + I(b,c,d) + X[k] + T[i]) <<< s). */
+#define I(x, y, z) ((y) ^ ((x) | ~(z)))
+#define SET(a, b, c, d, k, s, Ti)\
+  t = a + I(b,c,d) + X[k] + Ti;\
+  a = ROTATE_LEFT(t, s) + b
+     /* Do the following 16 operations. */
+    SET(a, b, c, d,  0,  6, T49);
+    SET(d, a, b, c,  7, 10, T50);
+    SET(c, d, a, b, 14, 15, T51);
+    SET(b, c, d, a,  5, 21, T52);
+    SET(a, b, c, d, 12,  6, T53);
+    SET(d, a, b, c,  3, 10, T54);
+    SET(c, d, a, b, 10, 15, T55);
+    SET(b, c, d, a,  1, 21, T56);
+    SET(a, b, c, d,  8,  6, T57);
+    SET(d, a, b, c, 15, 10, T58);
+    SET(c, d, a, b,  6, 15, T59);
+    SET(b, c, d, a, 13, 21, T60);
+    SET(a, b, c, d,  4,  6, T61);
+    SET(d, a, b, c, 11, 10, T62);
+    SET(c, d, a, b,  2, 15, T63);
+    SET(b, c, d, a,  9, 21, T64);
+#undef SET
+
+     /* Then perform the following additions. (That is increment each
+        of the four registers by the value it had before this block
+        was started.) */
+    pms->abcd[0] += a;
+    pms->abcd[1] += b;
+    pms->abcd[2] += c;
+    pms->abcd[3] += d;
+}
+
+void
+md5_init(md5_state_t *pms)
+{
+    pms->count[0] = pms->count[1] = 0;
+    pms->abcd[0] = 0x67452301;
+    pms->abcd[1] = 0xefcdab89;
+    pms->abcd[2] = 0x98badcfe;
+    pms->abcd[3] = 0x10325476;
+}
+
+void
+md5_append(md5_state_t *pms, const md5_byte_t *data, int nbytes)
+{
+    const md5_byte_t *p = data;
+    int left = nbytes;
+    int offset = (pms->count[0] >> 3) & 63;
+    md5_word_t nbits = (md5_word_t)(nbytes << 3);
+
+    if (nbytes <= 0)
+	return;
+
+    /* Update the message length. */
+    pms->count[1] += nbytes >> 29;
+    pms->count[0] += nbits;
+    if (pms->count[0] < nbits)
+	pms->count[1]++;
+
+    /* Process an initial partial block. */
+    if (offset) {
+	int copy = (offset + nbytes > 64 ? 64 - offset : nbytes);
+
+	memcpy(pms->buf + offset, p, copy);
+	if (offset + copy < 64)
+	    return;
+	p += copy;
+	left -= copy;
+	md5_process(pms, pms->buf);
+    }
+
+    /* Process full blocks. */
+    for (; left >= 64; p += 64, left -= 64)
+	md5_process(pms, p);
+
+    /* Process a final partial block. */
+    if (left)
+	memcpy(pms->buf, p, left);
+}
+
+void
+md5_finish(md5_state_t *pms, md5_byte_t digest[16])
+{
+    static const md5_byte_t pad[64] = {
+	0x80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+    };
+    md5_byte_t data[8];
+    int i;
+
+    /* Save the length before padding. */
+    for (i = 0; i < 8; ++i)
+	data[i] = (md5_byte_t)(pms->count[i >> 2] >> ((i & 3) << 3));
+    /* Pad to 56 bytes mod 64. */
+    md5_append(pms, pad, ((55 - (pms->count[0] >> 3)) & 63) + 1);
+    /* Append the length. */
+    md5_append(pms, data, 8);
+    for (i = 0; i < 16; ++i)
+	digest[i] = (md5_byte_t)(pms->abcd[i >> 2] >> ((i & 3) << 3));
+}
Index: protocols/md5.h
===================================================================
--- protocols/md5.h	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
+++ protocols/md5.h	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -0,0 +1,85 @@
+/*
+  Copyright (C) 1999 Aladdin Enterprises.  All rights reserved.
+  
+  This software is provided 'as-is', without any express or implied
+  warranty.  In no event will the authors be held liable for any damages
+  arising from the use of this software.
+
+  Permission is granted to anyone to use this software for any purpose,
+  including commercial applications, and to alter it and redistribute it
+  freely, subject to the following restrictions:
+
+  1. The origin of this software must not be misrepresented; you must not
+     claim that you wrote the original software. If you use this software
+     in a product, an acknowledgment in the product documentation would be
+     appreciated but is not required.
+  2. Altered source versions must be plainly marked as such, and must not be
+     misrepresented as being the original software.
+  3. This notice may not be removed or altered from any source distribution.
+
+  L. Peter Deutsch
+  ghost@aladdin.com
+
+ */
+/*
+  Independent implementation of MD5 (RFC 1321).
+
+  This code implements the MD5 Algorithm defined in RFC 1321.
+  It is derived directly from the text of the RFC and not from the
+  reference implementation.
+
+  The original and principal author of md5.h is L. Peter Deutsch
+  <ghost@aladdin.com>.  Other authors are noted in the change history
+  that follows (in reverse chronological order):
+
+  2004-03-09 Jelmer Vernooij add G_MODULE_EXPORT for Bitlbee
+  1999-11-04 lpd Edited comments slightly for automatic TOC extraction.
+  1999-10-18 lpd Fixed typo in header comment (ansi2knr rather than md5);
+	added conditionalization for C++ compilation from Martin
+	Purschke <purschke@bnl.gov>.
+  1999-05-03 lpd Original version.
+ */
+
+#ifndef md5_INCLUDED
+#  define md5_INCLUDED
+
+#include <glib.h>
+#include <gmodule.h>
+
+/*
+ * This code has some adaptations for the Ghostscript environment, but it
+ * will compile and run correctly in any environment with 8-bit chars and
+ * 32-bit ints.  Specifically, it assumes that if the following are
+ * defined, they have the same meaning as in Ghostscript: P1, P2, P3,
+ * ARCH_IS_BIG_ENDIAN.
+ */
+
+typedef unsigned char md5_byte_t; /* 8-bit byte */
+typedef unsigned int md5_word_t; /* 32-bit word */
+
+/* Define the state of the MD5 Algorithm. */
+typedef struct md5_state_s {
+    md5_word_t count[2];	/* message length in bits, lsw first */
+    md5_word_t abcd[4];		/* digest buffer */
+    md5_byte_t buf[64];		/* accumulate block */
+} md5_state_t;
+
+#ifdef __cplusplus
+extern "C" 
+{
+#endif
+
+/* Initialize the algorithm. */
+G_MODULE_EXPORT void md5_init(md5_state_t *pms);
+
+/* Append a string to the message. */
+G_MODULE_EXPORT void md5_append(md5_state_t *pms, const md5_byte_t *data, int nbytes);
+
+/* Finish the message and return the digest. */
+G_MODULE_EXPORT void md5_finish(md5_state_t *pms, md5_byte_t digest[16]);
+
+#ifdef __cplusplus
+}  /* end extern "C" */
+#endif
+
+#endif /* md5_INCLUDED */
Index: protocols/msn/msn.c
===================================================================
--- protocols/msn/msn.c	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ protocols/msn/msn.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -27,7 +27,7 @@
 #include "msn.h"
 
-static void msn_login( account_t *acc )
-{
-	struct gaim_connection *gc = new_gaim_conn( acc );
+static void msn_login( struct aim_user *acct )
+{
+	struct gaim_connection *gc = new_gaim_conn( acct );
 	struct msn_data *md = g_new0( struct msn_data, 1 );
 	
@@ -37,5 +37,5 @@
 	md->fd = -1;
 	
-	if( strchr( acc->user, '@' ) == NULL )
+	if( strchr( acct->username, '@' ) == NULL )
 	{
 		hide_login_progress( gc, "Invalid account name" );
Index: protocols/nogaim.c
===================================================================
--- protocols/nogaim.c	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ protocols/nogaim.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -145,19 +145,31 @@
 /* multi.c */
 
-struct gaim_connection *new_gaim_conn( account_t *acc )
+struct gaim_connection *new_gaim_conn( struct aim_user *user )
 {
 	struct gaim_connection *gc;
+	account_t *a;
 	
 	gc = g_new0( struct gaim_connection, 1 );
 	
-	/* Maybe we should get rid of this memory waste later. ;-) */
-	g_snprintf( gc->username, sizeof( gc->username ), "%s", acc->user );
-	g_snprintf( gc->password, sizeof( gc->password ), "%s", acc->pass );
-	
-	gc->irc = acc->irc;
-	gc->acc = acc;
-	acc->gc = gc;
+	gc->prpl = user->prpl;
+	g_snprintf( gc->username, sizeof( gc->username ), "%s", user->username );
+	g_snprintf( gc->password, sizeof( gc->password ), "%s", user->password );
+	/* [MD]	BUGFIX: don't set gc->irc to the global IRC, but use the one from the struct aim_user.
+	 * This fixes daemon mode breakage where IRC doesn't point to the currently active connection.
+	 */
+	gc->irc = user->irc;
 	
 	connections = g_slist_append( connections, gc );
+	
+	user->gc = gc;
+	gc->user = user;
+	
+	// Find the account_t so we can set its gc pointer
+	for( a = gc->irc->accounts; a; a = a->next )
+		if( ( struct aim_user * ) a->gc == user )
+		{
+			a->gc = gc;
+			break;
+		}
 	
 	return( gc );
@@ -177,4 +189,5 @@
 	
 	connections = g_slist_remove( connections, gc );
+	g_free( gc->user );
 	g_free( gc );
 }
@@ -207,18 +220,18 @@
 	va_end( params );
 
-	if( ( g_strcasecmp( set_getstr( &gc->irc->set, "strip_html" ), "always" ) == 0 ) ||
-	    ( ( gc->flags & OPT_CONN_HTML ) && set_getint( &gc->irc->set, "strip_html" ) ) )
+	if( ( g_strcasecmp( set_getstr( gc->irc, "strip_html" ), "always" ) == 0 ) ||
+	    ( ( gc->flags & OPT_CONN_HTML ) && set_getint( gc->irc, "strip_html" ) ) )
 		strip_html( text );
 	
 	/* Try to find a different connection on the same protocol. */
 	for( a = gc->irc->accounts; a; a = a->next )
-		if( a->prpl == gc->acc->prpl && a->gc != gc )
+		if( a->prpl == gc->prpl && a->gc != gc )
 			break;
 	
 	/* If we found one, include the screenname in the message. */
 	if( a )
-		irc_usermsg( gc->irc, "%s(%s) - %s", gc->acc->prpl->name, gc->username, text );
+		irc_usermsg( gc->irc, "%s(%s) - %s", gc->prpl->name, gc->username, text );
 	else
-		irc_usermsg( gc->irc, "%s - %s", gc->acc->prpl->name, text );
+		irc_usermsg( gc->irc, "%s - %s", gc->prpl->name, text );
 	
 	g_free( text );
@@ -229,6 +242,6 @@
 	struct gaim_connection *gc = d;
 	
-	if( gc->acc->prpl->keepalive )
-		gc->acc->prpl->keepalive( gc );
+	if( gc->prpl && gc->prpl->keepalive )
+		gc->prpl->keepalive( gc );
 	
 	return TRUE;
@@ -284,7 +297,6 @@
 	b_event_remove( gc->keepalive );
 	gc->flags |= OPT_LOGGING_OUT;
-	
 	gc->keepalive = 0;
-	gc->acc->prpl->close( gc );
+	gc->prpl->close( gc );
 	b_event_remove( gc->inpa );
 	
@@ -311,7 +323,7 @@
 		/* Uhm... This is very sick. */
 	}
-	else if( !gc->wants_to_die && set_getint( &irc->set, "auto_reconnect" ) )
-	{
-		int delay = set_getint( &irc->set, "auto_reconnect_delay" );
+	else if( !gc->wants_to_die && set_getint( irc, "auto_reconnect" ) )
+	{
+		int delay = set_getint( irc, "auto_reconnect_delay" );
 		
 		serv_got_crap( gc, "Reconnecting in %d seconds..", delay );
@@ -352,10 +364,10 @@
 	irc_t *irc = gc->irc;
 	
-	if( set_getint( &irc->set, "debug" ) && 0 ) /* This message is too useless */
+	if( set_getint( irc, "debug" ) && 0 ) /* This message is too useless */
 		serv_got_crap( gc, "Receiving user add from handle: %s", handle );
 	
 	if( user_findhandle( gc, handle ) )
 	{
-		if( set_getint( &irc->set, "debug" ) )
+		if( set_getint( irc, "debug" ) )
 			serv_got_crap( gc, "User already exists, ignoring add request: %s", handle );
 		
@@ -366,5 +378,5 @@
 	
 	memset( nick, 0, MAX_NICK_LENGTH + 1 );
-	strcpy( nick, nick_get( gc->irc, handle, gc->acc->prpl, realname ) );
+	strcpy( nick, nick_get( gc->irc, handle, gc->prpl, realname ) );
 	
 	u = user_add( gc->irc, nick );
@@ -378,13 +390,13 @@
 		u->user = g_strndup( handle, s - handle );
 	}
-	else if( *gc->acc->server )
+	else if( gc->user->proto_opt[0] && *gc->user->proto_opt[0] )
 	{
 		char *colon;
 		
-		if( ( colon = strchr( gc->acc->server, ':' ) ) )
-			u->host = g_strndup( gc->acc->server,
-			                     colon - gc->acc->server );
+		if( ( colon = strchr( gc->user->proto_opt[0], ':' ) ) )
+			u->host = g_strndup( gc->user->proto_opt[0],
+			                     colon - gc->user->proto_opt[0] );
 		else
-			u->host = g_strdup( gc->acc->server );
+			u->host = g_strdup( gc->user->proto_opt[0] );
 		
 		u->user = g_strdup( handle );
@@ -397,5 +409,5 @@
 	else
 	{
-		u->host = g_strdup( gc->acc->prpl->name );
+		u->host = g_strdup( gc->user->prpl->name );
 		u->user = g_strdup( handle );
 	}
@@ -445,5 +457,5 @@
 		u->realname = g_strdup( realname );
 		
-		if( ( gc->flags & OPT_LOGGED_IN ) && set_getint( &gc->irc->set, "display_namechanges" ) )
+		if( ( gc->flags & OPT_LOGGED_IN ) && set_getint( gc->irc, "display_namechanges" ) )
 			serv_got_crap( gc, "User `%s' changed name to `%s'", u->nick, u->realname );
 	}
@@ -467,5 +479,5 @@
 void show_got_added_yes( gpointer w, struct show_got_added_data *data )
 {
-	data->gc->acc->prpl->add_buddy( data->gc, data->handle );
+	data->gc->prpl->add_buddy( data->gc, data->handle );
 	add_buddy( data->gc, NULL, data->handle, data->handle );
 	
@@ -501,5 +513,5 @@
 	if( !u )
 	{
-		if( g_strcasecmp( set_getstr( &gc->irc->set, "handle_unknown" ), "add" ) == 0 )
+		if( g_strcasecmp( set_getstr( gc->irc, "handle_unknown" ), "add" ) == 0 )
 		{
 			add_buddy( gc, NULL, handle, NULL );
@@ -508,5 +520,5 @@
 		else
 		{
-			if( set_getint( &gc->irc->set, "debug" ) || g_strcasecmp( set_getstr( &gc->irc->set, "handle_unknown" ), "ignore" ) != 0 )
+			if( set_getint( gc->irc, "debug" ) || g_strcasecmp( set_getstr( gc->irc, "handle_unknown" ), "ignore" ) != 0 )
 			{
 				serv_got_crap( gc, "serv_got_update() for handle %s:", handle );
@@ -546,9 +558,9 @@
 	}
 	
-	if( ( type & UC_UNAVAILABLE ) && ( strcmp( gc->acc->prpl->name, "oscar" ) == 0 || strcmp( gc->acc->prpl->name, "icq" ) == 0 ) )
+	if( ( type & UC_UNAVAILABLE ) && ( !strcmp(gc->prpl->name, "oscar") || !strcmp(gc->prpl->name, "icq")) )
 	{
 		u->away = g_strdup( "Away" );
 	}
-	else if( ( type & UC_UNAVAILABLE ) && ( strcmp( gc->acc->prpl->name, "jabber" ) == 0 ) )
+	else if( ( type & UC_UNAVAILABLE ) && ( !strcmp(gc->prpl->name, "jabber") ) )
 	{
 		if( type & UC_DND )
@@ -559,7 +571,7 @@
 			u->away = g_strdup( "Away" );
 	}
-	else if( ( type & UC_UNAVAILABLE ) && gc->acc->prpl->get_status_string )
-	{
-		u->away = g_strdup( gc->acc->prpl->get_status_string( gc, type ) );
+	else if( ( type & UC_UNAVAILABLE ) && gc->prpl->get_status_string )
+	{
+		u->away = g_strdup( gc->prpl->get_status_string( gc, type ) );
 	}
 	else
@@ -567,5 +579,5 @@
 	
 	/* LISPy... */
-	if( ( set_getint( &gc->irc->set, "away_devoice" ) ) &&		/* Don't do a thing when user doesn't want it */
+	if( ( set_getint( gc->irc, "away_devoice" ) ) &&		/* Don't do a thing when user doesn't want it */
 	    ( u->online ) &&						/* Don't touch offline people */
 	    ( ( ( u->online != oo ) && !u->away ) ||			/* Voice joining people */
@@ -586,9 +598,9 @@
 	if( !u )
 	{
-		char *h = set_getstr( &irc->set, "handle_unknown" );
+		char *h = set_getstr( irc, "handle_unknown" );
 		
 		if( g_strcasecmp( h, "ignore" ) == 0 )
 		{
-			if( set_getint( &irc->set, "debug" ) )
+			if( set_getint( irc, "debug" ) )
 				serv_got_crap( gc, "Ignoring message from unknown handle %s", handle );
 			
@@ -597,5 +609,5 @@
 		else if( g_strncasecmp( h, "add", 3 ) == 0 )
 		{
-			int private = set_getint( &irc->set, "private" );
+			int private = set_getint( irc, "private" );
 			
 			if( h[3] )
@@ -618,6 +630,6 @@
 	}
 	
-	if( ( g_strcasecmp( set_getstr( &gc->irc->set, "strip_html" ), "always" ) == 0 ) ||
-	    ( ( gc->flags & OPT_CONN_HTML ) && set_getint( &gc->irc->set, "strip_html" ) ) )
+	if( ( g_strcasecmp( set_getstr( gc->irc, "strip_html" ), "always" ) == 0 ) ||
+	    ( ( gc->flags & OPT_CONN_HTML ) && set_getint( gc->irc, "strip_html" ) ) )
 		strip_html( msg );
 
@@ -659,5 +671,5 @@
 	user_t *u;
 	
-	if( !set_getint( &gc->irc->set, "typing_notice" ) )
+	if( !set_getint( gc->irc, "typing_notice" ) )
 		return;
 	
@@ -681,5 +693,5 @@
 	GList *ir;
 	
-	if( set_getint( &gc->irc->set, "debug" ) )
+	if( set_getint( gc->irc, "debug" ) )
 		serv_got_crap( gc, "You were removed from conversation %d", (int) id );
 	
@@ -720,5 +732,5 @@
 	
 	/* Gaim sends own messages through this too. IRC doesn't want this, so kill them */
-	if( g_strcasecmp( who, gc->username ) == 0 )
+	if( g_strcasecmp( who, gc->user->username ) == 0 )
 		return;
 	
@@ -726,6 +738,6 @@
 	for( c = gc->conversations; c && c->id != id; c = c->next );
 	
-	if( ( g_strcasecmp( set_getstr( &gc->irc->set, "strip_html" ), "always" ) == 0 ) ||
-	    ( ( gc->flags & OPT_CONN_HTML ) && set_getint( &gc->irc->set, "strip_html" ) ) )
+	if( ( g_strcasecmp( set_getstr( gc->irc, "strip_html" ), "always" ) == 0 ) ||
+	    ( ( gc->flags & OPT_CONN_HTML ) && set_getint( gc->irc, "strip_html" ) ) )
 		strip_html( msg );
 	
@@ -760,5 +772,5 @@
 	g_free( s );
 	
-	if( set_getint( &gc->irc->set, "debug" ) )
+	if( set_getint( gc->irc, "debug" ) )
 		serv_got_crap( gc, "Creating new conversation: (id=%d,handle=%s)", id, handle );
 	
@@ -774,9 +786,9 @@
 	int me = 0;
 	
-	if( set_getint( &b->gc->irc->set, "debug" ) )
+	if( set_getint( b->gc->irc, "debug" ) )
 		serv_got_crap( b->gc, "User %s added to conversation %d", handle, b->id );
 	
 	/* It might be yourself! */
-	if( b->gc->acc->prpl->cmp_buddynames( handle, b->gc->username ) == 0 )
+	if( b->gc->prpl->cmp_buddynames( handle, b->gc->user->username ) == 0 )
 	{
 		u = user_find( b->gc->irc, b->gc->irc->nick );
@@ -808,9 +820,9 @@
 	int me = 0;
 	
-	if( set_getint( &b->gc->irc->set, "debug" ) )
+	if( set_getint( b->gc->irc, "debug" ) )
 		serv_got_crap( b->gc, "User %s removed from conversation %d (%s)", handle, b->id, reason ? reason : "" );
 	
 	/* It might be yourself! */
-	if( g_strcasecmp( handle, b->gc->username ) == 0 )
+	if( g_strcasecmp( handle, b->gc->user->username ) == 0 )
 	{
 		u = user_find( b->gc->irc, b->gc->irc->nick );
@@ -870,7 +882,6 @@
 }
 
-char *set_eval_away_devoice( set_t *set, char *value )
-{
-	irc_t *irc = set->data;
+char *set_eval_away_devoice( irc_t *irc, set_t *set, char *value )
+{
 	int st;
 	
@@ -886,5 +897,5 @@
 	/* Horror.... */
 	
-	if( st != set_getint( &irc->set, "away_devoice" ) )
+	if( st != set_getint( irc, "away_devoice" ) )
 	{
 		char list[80] = "";
@@ -926,5 +937,5 @@
 	}
 	
-	return( set_eval_bool( set, value ) );
+	return( set_eval_bool( irc, set, value ) );
 }
 
@@ -946,5 +957,5 @@
 	}
 	
-	st = gc->acc->prpl->send_im( gc, handle, msg, strlen( msg ), flags );
+	st = gc->prpl->send_im( gc, handle, msg, strlen( msg ), flags );
 	g_free( buf );
 	
@@ -963,5 +974,5 @@
 	}
 	
-	st = gc->acc->prpl->chat_send( gc, id, msg );
+	st = gc->prpl->chat_send( gc, id, msg );
 	g_free( buf );
 	
@@ -977,5 +988,5 @@
 	
 	if( !away ) away = "";
-	ms = m = gc->acc->prpl->away_states( gc );
+	ms = m = gc->prpl->away_states( gc );
 	
 	while( m )
@@ -998,5 +1009,5 @@
 	if( m )
 	{
-		gc->acc->prpl->set_away( gc, m->data, *away ? away : NULL );
+		gc->prpl->set_away( gc, m->data, *away ? away : NULL );
 	}
 	else
@@ -1005,10 +1016,10 @@
 		if( s )
 		{
-			gc->acc->prpl->set_away( gc, s, away );
-			if( set_getint( &gc->irc->set, "debug" ) )
+			gc->prpl->set_away( gc, s, away );
+			if( set_getint( gc->irc, "debug" ) )
 				serv_got_crap( gc, "Setting away state to %s", s );
 		}
 		else
-			gc->acc->prpl->set_away( gc, GAIM_AWAY_CUSTOM, away );
+			gc->prpl->set_away( gc, GAIM_AWAY_CUSTOM, away );
 	}
 	
@@ -1062,10 +1073,10 @@
 void bim_add_allow( struct gaim_connection *gc, char *handle )
 {
-	if( g_slist_find_custom( gc->permit, handle, (GCompareFunc) gc->acc->prpl->cmp_buddynames ) == NULL )
+	if( g_slist_find_custom( gc->permit, handle, (GCompareFunc) gc->prpl->cmp_buddynames ) == NULL )
 	{
 		gc->permit = g_slist_prepend( gc->permit, g_strdup( handle ) );
 	}
 	
-	gc->acc->prpl->add_permit( gc, handle );
+	gc->prpl->add_permit( gc, handle );
 }
 
@@ -1074,5 +1085,5 @@
 	GSList *l;
 	
-	if( ( l = g_slist_find_custom( gc->permit, handle, (GCompareFunc) gc->acc->prpl->cmp_buddynames ) ) )
+	if( ( l = g_slist_find_custom( gc->permit, handle, (GCompareFunc) gc->prpl->cmp_buddynames ) ) )
 	{
 		g_free( l->data );
@@ -1080,15 +1091,15 @@
 	}
 	
-	gc->acc->prpl->rem_permit( gc, handle );
+	gc->prpl->rem_permit( gc, handle );
 }
 
 void bim_add_block( struct gaim_connection *gc, char *handle )
 {
-	if( g_slist_find_custom( gc->deny, handle, (GCompareFunc) gc->acc->prpl->cmp_buddynames ) == NULL )
+	if( g_slist_find_custom( gc->deny, handle, (GCompareFunc) gc->prpl->cmp_buddynames ) == NULL )
 	{
 		gc->deny = g_slist_prepend( gc->deny, g_strdup( handle ) );
 	}
 	
-	gc->acc->prpl->add_deny( gc, handle );
+	gc->prpl->add_deny( gc, handle );
 }
 
@@ -1097,5 +1108,5 @@
 	GSList *l;
 	
-	if( ( l = g_slist_find_custom( gc->deny, handle, (GCompareFunc) gc->acc->prpl->cmp_buddynames ) ) )
+	if( ( l = g_slist_find_custom( gc->deny, handle, (GCompareFunc) gc->prpl->cmp_buddynames ) ) )
 	{
 		g_free( l->data );
@@ -1103,4 +1114,4 @@
 	}
 	
-	gc->acc->prpl->rem_deny( gc, handle );
-}
+	gc->prpl->rem_deny( gc, handle );
+}
Index: protocols/nogaim.h
===================================================================
--- protocols/nogaim.h	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ protocols/nogaim.h	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -39,5 +39,4 @@
 
 #include "bitlbee.h"
-#include "account.h"
 #include "proxy.h"
 #include "md5.h"
@@ -64,5 +63,5 @@
 struct gaim_connection
 {
-	account_t *acc;
+	struct prpl *prpl;
 	guint32 flags;
 	
@@ -79,4 +78,6 @@
 	GSList *deny;
 	int permdeny;
+	
+	struct aim_user *user;
 	
 	char username[64];
@@ -125,9 +126,24 @@
 };
 
+struct aim_user {
+	char username[64];
+	char alias[SELF_ALIAS_LEN]; 
+	char password[32];
+	char user_info[2048];
+	int options;
+	struct prpl *prpl;
+	/* prpls can use this to save information about the user,
+	 * like which server to connect to, etc */
+	char proto_opt[7][256];
+
+	struct gaim_connection *gc;
+	irc_t *irc;
+};
+
 struct prpl {
 	int options;
 	const char *name;
 
-	void (* login)		(account_t *);
+	void (* login)		(struct aim_user *);
 	void (* keepalive)	(struct gaim_connection *);
 	void (* close)		(struct gaim_connection *);
@@ -190,5 +206,5 @@
 
 void nogaim_init();
-char *set_eval_away_devoice( set_t *set, char *value );
+char *set_eval_away_devoice( irc_t *irc, set_t *set, char *value );
 
 gboolean auto_reconnect( gpointer data, gint fd, b_input_condition cond );
@@ -196,5 +212,5 @@
 
 /* multi.c */
-G_MODULE_EXPORT struct gaim_connection *new_gaim_conn( account_t *acc );
+G_MODULE_EXPORT struct gaim_connection *new_gaim_conn( struct aim_user *user );
 G_MODULE_EXPORT void destroy_gaim_conn( struct gaim_connection *gc );
 G_MODULE_EXPORT void set_login_progress( struct gaim_connection *gc, int step, char *msg );
